
// TestAppDlg.cpp : Implementation file
//

#include "stdafx.h"
#include "TestApp.h"
#include "TestAppDlg.h"
#include "afxdialogex.h"


#include "AW_Function.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTestAppDlg dialog

#define FLG_READ	0x0000
#define FLG_WRITE	0x0001
#define FLG_READ_WRITE_MASK	0x0001

#define FLG_BYTE	0x0000
#define FLG_WORD	0x0002
#define FLG_BYTE_WORD_MASK	0x0002



#define FLG_READ_BYTE	(FLG_READ|FLG_BYTE)
#define FLG_WRITE_BYTE	(FLG_WRITE|FLG_BYTE)
#define FLG_READ_WORD	(FLG_READ|FLG_WORD)
#define FLG_WRITE_WORD	(FLG_WRITE|FLG_WORD)


AW_DEVICE_LIST AwDeviceList;


CTestAppDlg::CTestAppDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CTestAppDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BOARD_NO, Cmb_BoradNo);
	DDX_Control(pDX, IDC_EDIT1, Edt_Address);
	DDX_Control(pDX, IDC_EDIT2, Edt_Data);
	DDX_Control(pDX, IDC_EDIT3, Edt_ReturnValue);
	DDX_Control(pDX, IDC_BOARD_NAME, Lbl_BoradName);
	DDX_Control(pDX, IDC_ADDRESS_RANGE, Lbl_AddressRange);
	DDX_Control(pDX, IDC_BTN_GET_DEVICE_INFO, Btn_GetDeviceInfo);
	DDX_Control(pDX, IDC_BTN_READ_BYTE, Btn_ReadByte);
	DDX_Control(pDX, IDC_BTN_WRITE_BYTE, Btn_WriteByte);
	DDX_Control(pDX, IDC_BTN_READ_WORD, Btn_ReadWord);
	DDX_Control(pDX, IDC_BTN_WRITE_WORD, Btn_WriteWord);
}

BEGIN_MESSAGE_MAP(CTestAppDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_READ_BYTE, &CTestAppDlg::OnBnClickedBtnReadByte)
	ON_BN_CLICKED(IDC_BTN_WRITE_BYTE, &CTestAppDlg::OnBnClickedBtnWriteByte)
	ON_BN_CLICKED(IDC_BTN_READ_WORD, &CTestAppDlg::OnBnClickedBtnReadWord)
	ON_BN_CLICKED(IDC_BTN_WRITE_WORD, &CTestAppDlg::OnBnClickedBtnWriteWord)
	ON_BN_CLICKED(IDC_BTN_GET_DEVICE_INFO, &CTestAppDlg::OnBnClickedBtnGetDeviceInfo)
	ON_CBN_SELCHANGE(IDC_BOARD_NO, &CTestAppDlg::OnCbnSelchangeBoardNo)
END_MESSAGE_MAP()


// CTestAppDlg Message handler

BOOL CTestAppDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Set this dialog icon.
	// If the application's main window is not a dialog , Framework , perform this setting automatically.
	SetIcon(m_hIcon, TRUE);			// Set of large icons
	SetIcon(m_hIcon, FALSE);		// Set of small icons

	// TODO: Add the initialization here.

	Cmb_BoradNo.SetCurSel(0);

	return TRUE;  // Unless you set the focus to the control , it returns TRUE.
}

// If you want to add a minimize button in the dialog , you need code below in order to draw the icon.
//	 In the case of MFC applications that use the document / view model , 
//	this is automatically set by the Framework.

void CTestAppDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Device context of drawing

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// The center of the client rectangle in the region
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Drawing icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// For the user to get the cursor to display when you are dragging the minimized window,
//	the system will call this function .
HCURSOR CTestAppDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTestAppDlg::OnBnClickedBtnGetDeviceInfo(){
	// TODO: This is where you add a control notification handler code.
	CString tmpString;
	CString ComboString;


	int Count = AW_GetDeviceInfo(&AwDeviceList);

	if(Count <= 0){
		// There is no board ?
		return;
	}

	for(unsigned int i=0;i<AwDeviceList.BoardCount;i++){

		tmpString.Format("%X",AwDeviceList.DeviceInfo[i].BoardNo);
		Cmb_BoradNo.AddString(tmpString);
	}


	Btn_GetDeviceInfo.EnableWindow(FALSE);
	Btn_ReadByte.EnableWindow(TRUE);
	Btn_WriteByte.EnableWindow(TRUE);
	Btn_ReadWord.EnableWindow(TRUE);
	Btn_WriteWord.EnableWindow(TRUE);

	Cmb_BoradNo.EnableWindow(TRUE);
	Edt_Address.EnableWindow(TRUE);
	Edt_Data.EnableWindow(TRUE);
	Edt_ReturnValue.EnableWindow(TRUE);


	Cmb_BoradNo.SetCurSel(0);
	OnCbnSelchangeBoardNo();
}

void CTestAppDlg::OnCbnSelchangeBoardNo()
{
	// TODO: This is where you add a control notification handler code.

	int SelectIndex = Cmb_BoradNo.GetCurSel();


	if(SelectIndex>=0){
		CString tmpString;

		switch(AwDeviceList.DeviceInfo[SelectIndex].BoardType){
		case AW_TYPE_AP4801:
			tmpString = "AP48-01";
			break;
		case AW_TYPE_AP4802:
			tmpString = "AP48-02";
			break;
		default:
			tmpString = "unknown";
			break;
		}

		Lbl_BoradName.SetWindowTextA(tmpString);

		tmpString.Format("(0x0000-0x%04X)",AwDeviceList.DeviceInfo[SelectIndex].MemSize-1);
		Lbl_AddressRange.SetWindowTextA(tmpString);
	}





}


void CTestAppDlg::OnBnClickedBtnReadByte(){
	// Byte Read
	GetInputParam(FLG_READ_BYTE);

	UCHAR ByteData = 0;

	ReturnValue = AW_ReadByte(BoardNo,Address,&ByteData);
	Data = ByteData;

	SetResultParam(FLG_READ_BYTE);
}

void CTestAppDlg::OnBnClickedBtnWriteByte(){
	// Byte Write
	GetInputParam(FLG_WRITE_BYTE);

	ReturnValue = AW_WriteByte(BoardNo,Address,(UCHAR)Data);

	SetResultParam(FLG_WRITE_BYTE);
}


void CTestAppDlg::OnBnClickedBtnReadWord(){
	// Word Read
	GetInputParam(FLG_READ_WORD);

	USHORT WordData = 0;
	ReturnValue = AW_ReadWord(BoardNo,Address,&WordData);
	Data = WordData;

	SetResultParam(FLG_READ_WORD);
}


void CTestAppDlg::OnBnClickedBtnWriteWord(){
	// Word Write
	GetInputParam(FLG_WRITE_WORD);

	ReturnValue = AW_WriteWord(BoardNo,Address,(USHORT)Data);

	SetResultParam(FLG_WRITE_WORD);

}


int CTestAppDlg::GetInputParam(unsigned int Flg){
	CString tmpString;
	TCHAR*	pszEnd;

	Cmb_BoradNo.GetWindowTextA(tmpString);
	BoardNo = _tcstol(tmpString,&pszEnd,16);

	Edt_Address.GetWindowTextA(tmpString);
	Address = _tcstol(tmpString,&pszEnd,16);

	tmpString.Format("%04X",Address);
	Edt_Address.SetWindowTextA(tmpString);


	if((Flg & FLG_READ_WRITE_MASK) == FLG_WRITE){
		// Write

		Edt_Data.GetWindowTextA(tmpString);
		Data = _tcstol(tmpString,&pszEnd,16);

		if((Flg & FLG_BYTE_WORD_MASK) == FLG_BYTE){
			// BYTE
			Data &= 0x000000FF;
			tmpString.Format("%02X",Data);
		}else{
			// WORD
			Data &= 0x0000FFFF;
			tmpString.Format("%04X",Data);
		}
		Edt_Data.SetWindowTextA(tmpString);
	}



	return 0;
}

int CTestAppDlg::SetResultParam(unsigned int Flg){

	CString tmpString;

	tmpString.Format("%d",ReturnValue);
	Edt_ReturnValue.SetWindowTextA(tmpString);


	if((Flg & FLG_READ_WRITE_MASK) == FLG_READ){
		// Read

		if((Flg & FLG_BYTE_WORD_MASK) == FLG_BYTE){
			// BYTE
			tmpString.Format("%02X",Data);
		}else{
			// WORD
			tmpString.Format("%04X",Data);
		}
		Edt_Data.SetWindowTextA(tmpString);
	}


	return 0;
}



